#!/usr/bin/env python
# -*- coding:utf-8 -*-

# ##############################################################################
#     Base code from where the autogenerated code inherits
#
#     Copyright (C) 2021 Alba Synchrotron/CELLS, Cerdanyola Spain
#
#     This program is free software: you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation, either version 3 of the License, or
#     (at your option) any later version.
#
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
#
#     You should have received a copy of the GNU General Public License
#     along with this program.  If not, see [http://www.gnu.org/licenses/].
# ##############################################################################

import struck.sis830x


WRITE_OFFSET = -0x200


class AlbaStruck:
    """
This class represents the access to the hardware in the Alba's way due to the
program running in the fpga. It uses the python struck Card object that
provides access to the hardware (that is alba agnostic) and does the actions
in the way the RF group has programmed the card.

This specially applies for the write action.
    """
    __card = None
    __write_offset = None

    def __init__(self, device_or_index, write_offset=WRITE_OFFSET):
        self.__write_offset = write_offset
        self.__card = struck.sis830x.Card(device_or_index)
        self.__card.open()

    def __del__(self):
        if self.__card is not None:
            self.__card.close()

    def __str__(self):
        return f"{self.__card!s}"

    def __repr__(self):
        return f"{self.__card!r}"

    @property
    def write_offset(self):
        """
The alba's program running in the fpga has a convention of a fixed shift
between the read registers and the write ones.

This value can be established with the constructor. But it can be used a
different value if it is specified in the write_register() method.

:return: number of bytes between the read registers and the write ones.
        """
        return self.__write_offset

    def read_register(self, number):
        """
Read of a register in the fpga. Nothing special from the alba's programm.

:param number: address of the register.
:return: value in the requested register.
        """
        return self.__card.read_register(number)

    def read_registers(self, *registers):
        """
Use the lower level compiled call to get reads from many registers with the
minimum time.

:param registers: variable number of arguments that each is one
                  register number wanted to be read.
:return: Same length list with the value of each register
        """
        return self.__card.read_registers(*registers)

    def write_register(self, read_reg, value, confirmation=True,
                       force_write_offset=None):
        """
Write procedure specific for the programming way from the alba's program in
the fpga:
- given an even register number, the write will also be applied to the
  consecutive odd register.
- The confirmation for this write is in another readonly register.

:param read_reg: address of the read register.
:param value: setting to the register and its partner.
:param confirmation: if True it will provide a readback.
:param force_write_offset: If the readback distance is different
       that the specified in the object creation (or the default) this
       parameter can specify. It has no sense to use this if
       confirmation is not requested.
:return: None or the value returned by the confirmation.
        """
        if read_reg % 2 == 0:
            if force_write_offset is not None:
                write_reg = read_reg+force_write_offset
            else:
                write_reg = read_reg+self.__write_offset
            # self.__card.write_register(write_reg, value, confirmation=False)
            # self.__card.write_register(write_reg+1, value, confirmation=False)
            self.__card.write_registers((write_reg, value),
                                        (write_reg+1, value),
                                        confirmation=False)
            # TODO: there may be a delay in apply
            if confirmation:
                return self.__card.read_register(read_reg)
